/*
 * JBoss, Home of Professional Open Source.
 * Copyright 2006, Red Hat Middleware LLC, and individual contributors
 * as indicated by the @author tags. See the copyright.txt file in the
 * distribution for a full listing of individual contributors.
 *
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */
package org.jboss.bpm.console.client.util;

/**
 * Request helper, to bypass SOP restrictions.<br>
 * Can only be used to retrieve Json data, wrapped in a script tag.
 *
 * @author Heiko.Braun <heiko.braun@jboss.com>
 */
public class JSONRequest
{
  public static void get(String url, JSONRequestHandler handler)
  {
    String callbackName = "JSONCallback" + handler.hashCode();
    get(url + "?callback=" + callbackName, callbackName, handler);
  }

  public static void get(String url, String callbackName, JSONRequestHandler handler)
  {
    createCallbackFunction(handler, callbackName);
    addScript(url);
  }

  public static native void addScript(String url) /*-{
    var scr = document.createElement("script");
    scr.setAttribute("language", "JavaScript");
    scr.setAttribute("src", url);
    document.getElementsByTagName("body")[0].appendChild(scr);
  }-*/;

  private native static void createCallbackFunction(JSONRequestHandler obj, String callbackName)/*-{
    tmpcallback = function(j) {
      obj.@org.jboss.bpm.console.client.util.JSONRequestHandler::onRequestComplete(Lcom/google/gwt/core/client/JavaScriptObject;)(j);
    };
    eval( "window." + callbackName + "=tmpcallback" );
  }-*/;
}
